<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import axios from 'axios'
import Message from '@/views/chat/components/Message.vue'

const newMessage = ref('')

const messages = ref([
  { id: 1, text: 'Hi, I am ANA, how can I help you?', isUser: false },
])

const messagesContainer = ref<HTMLElement | null>(null)

const loading = ref<boolean>(false)
const apiResponse = ref(null)

const openaiToken: string = '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'

const openaiClient = axios.create({
  baseURL: 'https://api.openai.com/v1/chat',
  headers: {
    'Authorization': `Bearer ${openaiToken}`,
    'Content-Type': 'application/json',
  },
})

async function sendMessage(): Promise<void> {
  if (newMessage.value.trim() === '')
    return

  messages.value.push({
    id: messages.value.length + 1,
    text: newMessage.value,
    isUser: true,
  })

  loading.value = true

  const temp_input = newMessage.value

  newMessage.value = ''

  try {
    const response = await openaiClient.post('/completions', {
      model: 'gpt-3.5-turbo',
      messages: [
        {
          role: 'system',
          content: 'Hola, soy ANA, tu asistente virtual amigable. Estoy aquí para ayudarte con cualquier duda o solicitud relacionada con frameworks de desarrollo, programación y temas técnicos. No dudes en preguntar cualquier cosa que necesites. ANA es un Framework de desarrollo para CICD y automatización de todo tipo, pero enfocada en redes. De ahí viene su nombre (Advanced Network Automation) ANA. Aquí puedes explicar cualquier tema relacionado con esto',
        },
        {
          role: 'user',
          content: `Pregunta: ${temp_input}\nRespuesta:`,
        },
      ],
      max_tokens: 700,
      temperature: 0,
      top_p: 1,
      frequency_penalty: 0,
      presence_penalty: 0,
    })

    messages.value.push({
      id: messages.value.length + 1,
      text: response.data.choices[0].message.content,
      isUser: false,
    })

    console.log(response)
    apiResponse.value = response.data
  }
  catch (error: any) {
    console.error('Error al enviar el mensaje:', error)
    messages.value.push({
      id: messages.value.length + 1,
      text: `Error al enviar el mensaje: ${error.message}`,
      isUser: false,
    })
  }
  finally {
    loading.value = false
    await nextTick()
    scrollToBottom()
  }
}

function scrollToBottom(): void {
  if (messagesContainer.value)
    messagesContainer.value.scrollTop = messagesContainer.value.scrollHeight
}

onMounted(scrollToBottom)
</script>

<template>
  <VContainer class="chat-container">
    <VRow class="fill-height">
      <VCol
        ref="messagesContainer"
        class="messages"
      >
        <Message
          v-for="message in messages"
          :key="message.id"
          :text="message.text"
          :is-user="message.isUser"
        />
      </VCol>
    </VRow>
    <VRow>
      <VCol>
        <VTextField
          v-model="newMessage"
          label="Type a message..."
          outlined
          dense
          @keyup.enter="sendMessage"
        />
      </VCol>
    </VRow>
  </VContainer>
</template>

<style scoped>
.chat-container {
  display: flex;
  flex-direction: column;
  height: 500px;
  padding: 10px;
}

.messages {
  flex-grow: 1;
  overflow-y: auto;
}

.v-text-field {
  padding: 10px;
  font-size: 16px;
}
</style>
